------------------------------------------------------------------------------------------------------------------------------------------------------
--                                       TREINAMENTO ORACLE - PROVA DE CERTIFICAO 1Z0-047 SQL EXPERT Oracle 10g 11g 12c                                              --
--                                             CAPTULO 03 - Administrando Objetos com dicionrio de dados                                                    --
--                                                            INSTRUTOR PEDRO F. CARVALHO                                                           --
--                                                             WWW.PEDROFCARVALHO.COM.BR                                                            --
--                                                           CONTATO@PEDROFCARVALHO.COM.BR                                                          -- 
------------------------------------------------------------------------------------------------------------------------------------------------------
Links
http:/education.oracle.com/pls/web_prod-plq-dad/db_pages.getpage?page_id=5001&get_params=p_exam_id:1Z0-047

Contedo
  	Introduction to data dictionary
  	Querying the dictionary views for the following:
       Table information
       Column information
       Constraint information
  	Querying the dictionary views for the following:
       View information
       Sequence information
       Synonym information
       Index information
  	Adding a comment to a table and querying the dictionary views for comment information
  

Views de dicionrio de dados

Dicionrio de Dados

Uma das partes mais importantes de uma base de dados Oracle  o seu dicionrio de dados , que  um conjunto de tabelas somente leitura 
que fornece informaes sobre a base de dados. Um dicionrio de dados contm:

As definies de todos os objetos de esquema no banco de dados (tabelas, views, ndices, clusters, sinnimos, seqncias, procedimentos, 
funes, pacotes, triggers, e assim por diante).
Quanto espao foi alocado, e  usado atualmente por, os objetos de esquema.
Os valores padro para colunas.
Informaes restrio de integridade.
Os nomes de usurios Oracle.
Quais Privilgios e funes de cada usurio foi concedida.
Informaes de auditoria, como quem tem acessado ou atualizado vrios objetos de esquema.
Informaes de banco de dados geral.
O dicionrio de dados  estruturado em tabelas e exibies, assim como dados de outros bancos de dados. Todas as tabelas do dicionrio de 
dados e pontos de vista para um determinado banco de dados so armazenados no banco de dados do tablespace SYSTEM.

Como usar o Dicionrio de Dados

Os pontos de vista do dicionrio de dados servem como referncia para todos os usurios do banco de dados. Acessar os pontos de 
vista do dicionrio de dados com instrues SQL. Algumas opinies so acessveis a todos os usurios do Oracle, e outros so 
destinados a somente administradores de banco de dados.

O dicionrio de dados est sempre disponvel quando o banco de dados  aberto. Ele reside no tablespace SYSTEM, o qual est
sempre online.

Prefixos
USER_	Vista do usurio (o que est no esquema do usurio)
ALL_	Viso do usurio expandido (o que o usurio pode acessar)
DBA_	Vista do administrador de banco de dados (esquemas de todos os usurios)
V$

SELECT *
FROM   dictionary
WHERE  table_name = 'USER_OBJECTS';

SELECT object_name, object_type, created, status
FROM   user_objects -- all_objects ou dba_objects
ORDER BY object_type;

SELECT table_name
FROM   user_tables; -- all_tables -- dba_tables


SELECT * --column_name, data_type, data_length, data_precision, data_scale, nullable
FROM   user_tab_columns -- mostra os campos de todas as tabelas do banco
WHERE  table_name = 'EMPLOYEES';


SELECT constraint_name, constraint_type, search_condition, r_constraint_name, delete_rule, status 
FROM   user_constraints -- consulta todas as constraints do banco
WHERE  table_name = 'EMPLOYEES';

SELECT * --constraint_name, column_name
FROM   user_cons_columns
WHERE  table_name = 'EMPLOYEES';


SELECT * --view_name 
FROM user_views; -- all_views ou dba_views


SELECT * from user_sequences

SELECT * from user_indexes -- all_indexes ou dba_indexes

SELECT index_name, column_name,table_name
FROM   user_ind_columns
WHERE  index_name = 'EMP_EMAIL_UK';

SELECT *
FROM   user_synonyms;

COMMENT ON TABLE employees
IS 'Employee Information 2';

COMMENT ON COLUMN employees.first_name
IS 'First name of the employee';

select * from ALL_COL_COMMENTS
where table_name = 'EMPLOYEES'
USER_COL_COMMENTS

SELECT * FROM ALL_TAB_COMMENTS
where table_name = 'EMPLOYEES'

USER_TAB_COMMENTS

	DICTIONARY
    	USER_OBJECTS
    	USER_TABLES
    	USER_TAB_COLUMNS
    	USER_CONSTRAINTS
    	USER_CONS_COLUMNS
    	USER_VIEWS
    	USER_SEQUENCES
    	USER_INDEXES
    	USER_SYNONYMS
 -- UMA COM A OUTRA FAZER SELECT COM RELACIONAMENTO ENTRE ELAS.


-- Passos de estudos
-- 1 - Assitir a video aula somente observando 2x
-- 2 - Assitir a video aula agora fazendo os scritps 2x
-- 3 - Acessar pasta exerccios e dar uma olhada nos exerccios
-- 4 - Realizar os exerccios de fixao abaixo e encaminhar os selects no meu email
       -- Obs : Premio para quem acertar todos


1. Query the data dictionary to see information about the tables you own.

2. Query the dictionary view to see information about all the tables that you can access.
Exclude tables that you own.

3.  For a specified table, create a script that reports the column names, data types, and
data types lengths, as well as whether nulls are allowed. Prompt the user to enter the
table name. Give appropriate aliases to the DATA_PRECISION and DATA_SCALE
columns. Save this script in a file named lab_03_01.sql.  

To test, run the script and enter DEPARTMENTS as the table name.
4. Create a script that reports the column name, constraint name, constraint type, search
condition, and status for a specified table. You must join the USER_CONSTRAINTS
and USER_CONS_COLUMNS tables to obtain all this information. Prompt the user to
enter the table name. Save the script in a file named lab_03_04.sql.


5. Add a comment to the DEPARTMENTS table. Then query the
USER_TAB_COMMENTS view to verify that the comment is present.


6. Create a synonym for your EMPLOYEES table. Call it EMP. Then, find the names of
all the synonyms that are in your schema.

7. Run lab_03_07.sql to create the dept50 view for this exercise. You need to
determine the names and definitions of all the views in your schema. Create a report
that retrieves view information: the view name and text from the USER_VIEWS data
dictionary view.

Note: The EMP_DETAILS_VIEW	was created as part of your schema.  

Note: You can see the complete definition of the view if you use Run Script (or press
F5) in SQL Developer. If you use Execute Statement (or press F9) in SQL
Developer, scroll horizontally in the result pane. If you use SQL*Plus to see more
contents of a LONG column, use the SET LONG	n command, where n is the value
of the number of characters of the LONG column that you want to see.

8. Find the names of your sequences. Write a query in a script to display the following
information about your sequences: sequence name, maximum value, increment size,
and last number. Name the script lab_03_08.sql. Run the statement in your
script.

9. Confirm that both the DEPT2 and EMP2 tables are stored in the data dictionary.

10. Query the data dictionary to find out the constraint names and types for both the
tables.

11. Query the data dictionary to display the object names and types for both the tables.

12. Create the SALES_DEPT table based on the following table instance chart. Name the
index for the PRIMARY KEY column as SALES_PK_IDX. Then query the data
dictionary view to find the index name, table name, and whether the index is unique











