------------------------------------------------------------------------------------------------------------------------------------------------------
--                                       TREINAMENTO ORACLE - PROVA DE CERTIFICAO 1Z0-047 SQL EXPERT Oracle 10g 11g 12c                                              --
--                                             CAPTULO 06 - Recuperando dados usando subqueries                                                    --
--                                                            INSTRUTOR PEDRO F. CARVALHO                                                           --
--                                                             WWW.PEDROFCARVALHO.COM.BR                                                            --
--                                                           CONTATO@PEDROFCARVALHO.COM.BR                                                          -- 
------------------------------------------------------------------------------------------------------------------------------------------------------
Links
http:/education.oracle.com/pls/web_prod-plq-dad/db_pages.getpage?page_id=5001&get_params=p_exam_id:1Z0-047


Write a multiple-column subquery
Use scalar subqueries in SQL and Solve problems with correlated subqueries
Update and delete rows by using correlated subqueries
Use the EXISTS and NOT EXISTS operators
Use the WITH clause



-- subquery pareada

create table empl_demo as select * from employees


explain plan for
SELECT	employee_id, manager_id, department_id
FROM empl_demo
WHERE  (manager_id, department_id) IN
                                      (SELECT manager_id, department_id
                                       FROM empl_demo
                                       WHERE first_name = 'John')
                                       AND first_name <> 'John';
select * from table(dbms_xplan.display);

-- subquery no pareada
explain plan for
SELECT  employee_id, manager_id, department_id
FROM    empl_demo
WHERE   manager_id IN (SELECT manager_id 
                       FROM empl_demo
                       WHERE first_name = 'John')
AND     department_id IN (SELECT department_id
                       FROM empl_demo
                       WHERE first_name = 'John') 
                       AND first_name <> 'John';
select * from table(dbms_xplan.display);
                       


-- scalar/correlacionada subqueries
SELECT   employee_id, last_name
FROM     employees e
ORDER BY (SELECT department_name
          FROM departments d
          WHERE e.department_id = d.department_id);
          
SELECT last_name, salary, department_id
FROM   employees outer_table
WHERE  salary >
                (SELECT AVG(salary)
                  FROM   employees inner_table
                  WHERE inner_table.department_id = outer_table.department_id);
                  
SELECT e.employee_id, last_name, e.job_id
FROM   employees e
WHERE  2 <= (SELECT COUNT(*)
              FROM   job_history
              WHERE  employee_id = e.employee_id);
              
-- exemplo pratico de consultas correlacionadas
SELECT cd_paciente, 
       cd_convenio,
      (Select count(*) from tb_atendime where cd_convenio = tb.cd_convenio)
FROM tb_atendime tb;              
              
-- update correlacionado

UPDATE empl6 e SET department_name = 
                                        (SELECT department_name
                                        FROM   departments d
                                        WHERE  e.department_id = d.department_id);

                  
-- delete correlacionado
DELETE FROM empl6 E
WHERE employee_id =  
                  (SELECT employee_id
                    FROM   emp_history
                    WHERE  employee_id = E.employee_id);

-- with
with
  dept_costs  AS (
      SELECT d.department_name, SUM(e.salary) AS dept_total
      FROM   employees e JOIN departments d
      ON     e.department_id = d.department_id
      GROUP BY d.department_name),
  avg_cost    AS (
      SELECT SUM(dept_total)/COUNT(*) AS dept_avg
      FROM   dept_costs)

SELECT * 
FROM   dept_costs
WHERE  dept_total >
                    (SELECT dept_avg 
                    FROM avg_cost)
                    ORDER BY department_name


              
              
-- usando EXISTS

SELECT employee_id, last_name, job_id, department_id
FROM   employees outer
WHERE  EXISTS ( SELECT 'X'
                FROM   employees
                WHERE  manager_id = outer.employee_id);

              
SELECT department_id, department_name
FROM departments d
WHERE NOT EXISTS (SELECT 'X'
                    FROM   employees
                    WHERE  department_id = d.department_id);
              

-- Passos de estudos
-- 1 - Assitir a video aula somente observando 2x
-- 2 - Assitir a video aula agora fazendo os scritps 2x
-- 3 - Acessar pasta exerccios e dar uma olhada nos exerccios
-- 4 - Realizar os exerccios de fixao abaixo e encaminhar os selects no meu email
       -- Obs : Premio para quem acertar todos
       
       
1. Write a query to display the last name, department number, and salary of any
employee whose department number and salary match the department number and
salary of any employee who earns a commission.

2.   Display the last name, department name, and salary of any employee whose salary
and commission match the salary and commission of any employee located in
location ID1700.

3. Create a query to display the last name, hire date, and salary for all employees
who have the same salary and commission as Kochhar.
Note: Do not display Kochhar in the result set.

4.   Create a query to display the employees who earn a salary that is higher than the
salary of all the sales managers (JOB_ID = 'SA_MAN'). Sort the results on
salary from the highest to the lowest.

5.  Display details such as the employee ID, last name, and department ID of those
employees who live in cities the names of which begin with T.

6.   Write a query to find all employees who earn more than the average salary in their
departments. Display last name, salary, department ID, and the average salary for
the department. Sort by average salary. Use aliases for the columns retrieved by
the query as shown in the sample output.



       
       
       
       



