------------------------------------------------------------------------------------------------------------------------------------------------------
--                                       TREINAMENTO ORACLE - PROVA DE CERTIFICAO 1Z0-047 SQL EXPERT Oracle 10g 11g 12c                           --
--                                                     CAPTULO 07 - Expressoes Regulares                                                           --
--                                                            INSTRUTOR PEDRO F. CARVALHO                                                           --
--                                                             WWW.PEDROFCARVALHO.COM.BR                                                            --
--                                                           CONTATO@PEDROFCARVALHO.COM.BR                                                          -- 
------------------------------------------------------------------------------------------------------------------------------------------------------
Links
http:/education.oracle.com/pls/web_prod-plq-dad/db_pages.getpage?page_id=5001&get_params=p_exam_id:1Z0-047

Mais
http://docs.oracle.com/cd/B12037_01/appdev.101/b10795/adfns_re.htm

	Introduction to regular expressions
	Using metacharacters with regular expressions
	Using the regular expressions functions:
  	REGEXP_LIKE
  	REGEXP_REPLACE
  	REGEXP_INSTR
  	REGEXP_SUBSTR
	Accessing subexpressions
	Using the REGEXP_COUNT function
	Regular expressions and check constraints

Expresses regulares representam uma poderosa ferramenta para descrio e busca de padres em diversos tipos de suporte de dados. 
Esses podem ser bases de dados, textos ou mesmo na prpria Internet, como podemos presumir a busca, com a utilizao de  padres, 
 uma atividade bastante comum, em diversas reas do conhecimento,  e que  j possui um instrumental bastante variado em todos os 
tipos de sistemas, sejam eles tipicamente comerciais ou cientficos. Nesse contexto situa-se a importncia de ferramentas cada vez 
mais versteis, quer sejam de extrao de conhecimento ou de identificao de dados. Nesse ponto introduzimos uma tcnica que poder 
servir perfeitamente aqueles que necessitam de mais ferramentas para realizar suas pesquisas em suas bases de dados: Expresses 
Regulares.

Para utilizao de Expresses Regulares, se faz necessrio conhecer alguns metacaracteres( entenda por curingas ou alias) que 
so encontrados na utlizao de ERs.

       - \ : Caractere de escape -> trata o prximo caractere como um literal na expresso
       - * : Quantificador estrela -> combina zero ou mais ocorrncias de uma subexpresso precedendo o meta caractere.
       - . : Ponto -> combina qualquer caractere.
       - + : Quantificador mais -> combina uma ou mais ocorrncias da subexpresso precendendo o caractere meta.
       - ^ : Incio de ncora de linha -> combina a prxima expresso quando ela ocorre no incio de uma linha.
       - $ : Fim de ncora de linha -> combina a expressa precedente somente quando ela ocorre no final de uma   linha.
       - [...] : Lista de caracteres de combinao -> combina qualquer caractere na lista.
       - [^...] : Lista de caracteres que no combinam -> combina qualquer caractere que no est na lista.
       - ? : Quantificador de marca de questo -> combina zero ou uma ocorrncia de uma subexpresso    precedendo o meta caractere.
       - {m} : Intervalo -> combina exatamente m ocorrncias do caractere.
       - {m,} : Intervalo -> combina no mnimo m ocorrncias do caractere.
       - {m,n} : Intervalo -> combina no mnimo m ocorrncia do caractere e no mximo n ocorrncias da subexpresso precedente.
       - \n : Referencia de volta -> combina a nth subexpresso precedente, where n  um inteiro de 1 a 9
       - | : Operador OR -> combina ambos os caracteres ou palavras.
       - (...) : Subexpresso ou agrupamento -> combina uma expresso como uma unidade.
      - [:class:] : Classe de caracteres POSIX -> combina qualquer caractere pertencendo a uma classe especificada de caracteres.


-- REGEXP_LIKE
SELECT first_name, last_name
FROM employees
WHERE REGEXP_LIKE (first_name, '^Ste(v|ph)en$');
--WHERE first_name like 'Stev%' or first_name like 'Steph%'

-- REGEXP_REPLACE
SELECT phone_number, REGEXP_REPLACE(phone_number, '\.','-') AS phone
FROM employees;

-- REG_INSTR
SELECT street_address,
        REGEXP_INSTR(street_address,'[[:alpha:]]') AS First_Alpha_Position
FROM  locations;

-- REG_SUBSTR
SELECT street_address, REGEXP_SUBSTR(street_address , ' [^ ]+ ') AS Road
FROM locations;      

-- SUBEXPRESSIONS
SELECT   REGEXP_INSTR
        ('0123456789',      -- source char or search value
        '(123)(4(56)(78))', -- regular expression patterns
        1,                  -- position to start searching
        1,                  -- occurrence
        0,                  -- return option
        'i',                -- match option (case insensitive)
        1)             -- sub-expression on which to search    
        "Position"
FROM dual;


SELECT REGEXP_INSTR('ccacctttccctccactcctcacgttctcacctgtaaagcgtccctc
                      cctcatccccatgcccccttaccctgcagggtagagtaggctagaaaccagagagctccaagc
                      tccatctgtggagaggtgccatccttgggctgcagagagaggagaatttgccccaaagctgcc
                      tgcagagcttcaccacccttagtctcacaaagccttgagttcatagcatttcttgagttttca
                      ccctgcccagcaggacactgcagcacccaaagggcttcccaggagtagggttgccctcaagag
                      gctcttgggtctgatggccacatcctggaattgttttcaagttgatggtcacagccctgaggc
                      atgtaggggcgtggggatgcgctctgctctgctctcctctcctgaacccctgaaccctctggc
                      taccccagagcacttagagccag',     
                      '(gtc(tcac)(aaag))', 
                      1, 1, 0, 'i',
                      1) "Position"
FROM dual;


select REGEXP_SUBSTR
      ('acgctgcactgca', -- source char or search value
      'acg(.*)gca',    -- regular expression pattern
      1,               -- position to start searching
      1,               -- occurrence
      'i',             -- match option (case insensitive)
      1)               -- sub-expression  
     "Value"
FROM dual;


SELECT REGEXP_COUNT(  'ccacctttccctccactcctcacgttctcacctgtaaagcgtccctccctcatccccatgcccccttaccctgcag 
                      ggtagagtaggctagaaaccagagagctccaagctccatctgtggagaggtgccatccttgggctgcagagagaggag
                      aatttgccccaaagctgcctgcagagcttcaccacccttagtctcacaaagccttgagttcatagcatttcttgagtt
                      ttcaccctgcccagcaggacactgcagcacccaaagggcttcccaggagtagggttgccctcaagaggctcttgggtc
                      tgatggccacatcctggaattgttttcaagttgatggtcacagccctgaggcatgtaggggcgtggggatgcgctctg
                      ctctgctctcctctcctgaacccctgaaccctctggctaccccagagcacttagagccag',
                      'gtc') AS Count
FROM dual;         

ALTER TABLE emp8
ADD CONSTRAINT email_addr    
CHECK(REGEXP_LIKE(email,'@')) NOVALIDATE;

INSERT INTO emp8 VALUES  
(500,'Christian','Patel','ChrisP2creme.com',     
1234567890,'12-Jan-2004','HR_REP',2000,null,102,40);

create table t5 (email varchar(50));
alter table t5 add constraint email_addr check(regexp_like(email,'@'));

insert into t5 values ('contato@pedrofcarvalho.com.br');

-- erro de contrains check
              

-- Passos de estudos
-- 1 - Assitir a video aula somente observando 2x
-- 2 - Assitir a video aula agora fazendo os scritps 2x
-- 3 - Acessar pasta exerccios e dar uma olhada nos exerccios
-- 4 - Realizar os exerccios de fixao abaixo e encaminhar os selects no meu email
       -- Obs : Premio para quem acertar todos
       
       
1. Write a query to search the EMPLOYEES table for all employees whose first
names start with Ki or Ko.

2. Create a query that removes the spaces in the STREET_ADDRESS column of the
LOCATIONS table in the display. Use Street Address as the column heading.

3. Create a query that displays St replaced by Street in the STREET_ADDRESS
column of the LOCATIONS table. Be careful that you do not affect any rows that
already have Street in them. Display only those rows, which are affected.

4.   Create a contacts table and add a check constraint to the p_number column to
enforce the following format mask to ensure that phone numbers are entered into
the database in the following standard format: (XXX) XXX-XXXX. The table
should have the following columns:
	l_name varchar2(30)
	p_number varchar2 (30)

5. Run the lab_07_05.sql SQL script to insert the following seven phone
numbers into the contacts table. Which numbers are added?
Only the first two INSERT statements use a format that conforms to the
c_contacts_pnf constraint; the remaining statements generate CHECK
constraint errors.

6.   Write a query to find the number of occurrences of the DNA pattern ctc in the 
string gtctcgtctcgttctgtctgtcgttctg. Use the alias Count_DNA. Ignore
case-sensitivity.





